<?php
// $Id: datasync_cronalt.job.inc,v 1.1.2.1 2009/07/28 20:41:40 andrewlevine Exp $

class datasync_cronalt extends datasync_job {
  // Definitions of the different phases DataSync will run through
  // each phase should have a corresponding method
  public function phase_defs() {
    return array('run_cron');
  }
  
  // Definition of configuration options. In this case we are
  // telling datasync to run all phases inside of database
  // transactions 
  public function config_defs() {
    return array('phase_in_transaction' => $this->phase_defs());
  }
  
  // Definition of phase
  public function run_cron() {
    $data = $this->extra_data();
    $module = $data['datasync_cronalt'];
    $cron_func = $module . '_cron';
    
    if ($module != '<all>' && !function_exists($cron_func)) {
      watchdog('datasync', 'DATASYNC_CRONALT: Function @func does not exist for module @mod', array('@func' => $cron_func, '@mod' => $module,), WATCHDOG_ERROR);
      return FALSE;
    }
    
    if ($module == '<all>') {
      module_invoke_all('cron');
    }
    else {
      $cron_func();
    }
    watchdog('datasync', 'DATASYNC_CRONALT: Invoked @func for module @mod', array('@func' => $cron_func, '@mod' => $module,));
    return TRUE;
  }
}

